from PyQt5.QtWidgets import QWidget, QLabel, QPushButton
from PyQt5 import QtCore


class ManualIdWidget(QWidget):
    def __init__(self, protocol, parent=None):
        QWidget.__init__(self, parent)

        self.protocol = protocol
        self.parent = parent

        self.setGeometry(226, 77, 573-226, 449-77)
        self.setAttribute(QtCore.Qt.WA_StyledBackground)

        labels = [
            {'label': '1', 'name': None},
            {'label': '2', 'name': None},
            {'label': '3', 'name': None},
            {'label': '4', 'name': None},
            {'label': '5', 'name': None},
            {'label': '6', 'name': None},
            {'label': '7', 'name': None},
            {'label': '8', 'name': None},
            {'label': '9', 'name': None},
            {'label': None, 'name': 'delete'},
            {'label': '0', 'name': None},
            {'label': None, 'name': 'done'}
        ]

        info = QLabel(None, self)
        info.setGeometry(0, 0, 573-226, 66)
        self.info = info

        i = 0

        for row in range(0, 4):
            for col in range(0, 3):
                button = QPushButton(labels[i]['label'], self)
                button.setGeometry(col * 119, 80 + row * 75, 110, 66)

                name = labels[i]['name']
                if name:
                    button.setObjectName(name)

                if i == 9:
                    button.clicked.connect(self.deleteClick)
                    self.delete = button
                elif i == 11:
                    button.clicked.connect(self.doneClick)
                    self.done = button
                else:
                    button.clicked.connect(self.charClick)

                i += 1

        self.setInfo('')

    def setInfo(self, text):
        self.text = text

        if len(text) > 0:
            self.info.setText('ID: %s' % text)
        else:
            self.info.setText('')

    def charClick(self):
        if len(self.text) < 12:
            self.setInfo(self.text + self.sender().text())

    def deleteClick(self):
        self.setInfo(self.text[:-1])

    def doneClick(self):
        if len(self.text) > 0:
            self.protocol.manual(self.text)
            self.setInfo('')
            self.parent.manualHide()
