from PyQt5.QtWidgets import QWidget, QPushButton, QRadioButton
from PyQt5 import QtCore


class PrefManualIdWidget(QWidget):
    def __init__(self, protocol, main_window, parent=None):
        QWidget.__init__(self, parent)

        self.parent = parent
        self.protocol = protocol
        self.main_window = main_window
        self.value = main_window.manual_id

        self.setGeometry(0, 0, 800, 480)
        self.setAttribute(QtCore.Qt.WA_StyledBackground)

        self.close = QPushButton(None, self)
        self.close.setFlat(True)
        self.close.setGeometry(40, 10, 50, 50)
        self.close.setObjectName('close')

        button = QRadioButton(_("Стандартная идентификация"), self)
        button.setChecked(not self.value)
        button.clicked.connect(lambda: self.radioClick(False))
        button.setGeometry(208, 138, 605-208, 50)

        button = QRadioButton(_("Ввод ID"), self)
        button.setChecked(self.value)
        button.clicked.connect(lambda: self.radioClick(True))
        button.setGeometry(208, 208, 605-208, 50)

        save = QPushButton(_("Сохранить"), self)
        save.setFlat(True)
        save.setGeometry(26, 413, 224-26, 462-413)
        save.setObjectName('save')
        save.clicked.connect(self.saveClick)

    def radioClick(self, on):
        self.value = on

    def saveClick(self):
        self.protocol.setSettings({'licon_manual_id': self.value})
        self.parent.closeClick()
